Infrastructure - Story #7832

migrate from JibX to JAXB for XML binding / codegen
2016-06-24 19:12 - Rob Nahf

Status: In Progress Start date: 2016-06-24
Priority: Normal Due date:

Assignee: Rob Nahf % Done: 30%
Category: d1_common_java Estimated time: 0.00 hour

Target version:

Story Points:

Description

JibX is losing support in the community - not finding willing partners for maintainance - while JAXB has become the standard XML
binding framework for Java. We plan to migrate / switch to JAXB for object un/marshalling and most likely datatype code generation.

Subtasks:

Task # 7833: compare JAXB generated class files to current classes Closed
Task # 7834: develop maven configuration Rejected
Task # 7836: refactor JiBXException out of TypeMarshaller methods Closed
Task # 7844: support deep-copy cloning of service types Closed
Task # 7845: create marshaling adapters to handle malformed (empty) lists Closed
Task # 7846: set up types to use JAXB, add JAXB logic to TypeMarshaller Closed
Task # 7852: compare performance vs JibX Closed
Task # 7910: schema validation behavior New

Related issues:
Related to Infrastructure - Bug #7282: Can't build d1_common_java under java 1.8 Closed 2015-07-29

Associated revisions

Revision 18281 - 2016-08-18 21:42 - Rob Nahf

refs: #7832: Removed jibx and BCEL dependencies, now that JAXB has been benchmarked against JiBX favorably. Refactored
TypeSmaplesTestCase to use the TypeMarshaller, instead of JiBX classes.

Revision 18320 - 2016-10-12 20:03 - Rob Nahf

refs #7832: removed outdated JiBX configurations files. Added 2.0.1 schema files and configurations for schema validation in the TypeMarshaller.
Added validateAgainstSchema method for efficient validation (used in Sync)

History

#1 - 2016-06-24 19:12 - Rob Nahf
- Related to Bug #7282: Can't build d1_common_java under java 1.8 added

#2 - 2016-06-27 22:16 - Rob Nahf

basic marshalling will create an empty type (no values set) that we've determined is problematic when unmarshalling, for example:
<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
if using schema code generation, we would have to add special handling to get desired behavior (throwing an exception).

(see #7745)
#3 - 2016-06-28 17:00 - Rob Nahf

standard xjc annotations are not getting all of the properties in our classes from the schema, for example, Checksum is only catching the "value" field,
not the "algorithm" field.

#4 - 2016-06-28 23:47 - Rob Nahf

xjc did not generate classes for 4 types in dataoneTypes.xsd:

) ObjectFormatidentifier
) MonitorInfo
) MonitorList
)

1
2
3
4) DescribeResponse

Were these ever JiBX code generated?

ObjectFormatiDentifier could probably be because it was declared a simpleType instead of a complexType. (Or could it be that the class name is so
looooooooong. :-) )

#5 - 2016-06-29 05:20 - Rob Nahf

Was able to get the TypeMarshallerTestCase to pass on a JAXB-based TypeMarshaller class (refactored from the JiBX-based on in
d1_common_java), and with JAXB annotated copies of existing service.type classes.

e need to make sure package-info.java is in the types package
¢ need to make sure the @XMLRootElement(name = "lowerCaseClassName")
* make sure the List element properties use the un-list name for the property, i.e.: List subject, instead of List<Subject subjectList

Still need to adapt all of the types with XMLAnnotations...
Still need to verify that Dates marshall correctly
Still need to verify that lists become lists...

#6 - 2016-08-18 21:47 - Rob Nahf

Finished conversion from JibX to JAXB, using only a cache for the marshalling contexts as recommended. Caching the Marshallers and
unmarsahllers themselves was tested, but didn't lead to a performance gain, so that code was removed. (The complication of adding ThreadLocals to
make the TypeMarshaller thread safe was the primary consideration against leaving it in.

Removed JibX and BCEL configurations from pom.xml, as well as d1-jibx-extensions as a project dependency.

#7 - 2018-01-17 19:06 - Dave Vieglais
- Sprint set to CCI-2.3.8

#8 - 2018-01-17 19:06 - Dave Vieglais

- % Done changed from 0 to 30

- Status changed from New to In Progress
